/*
 *  Ksznm a tippeket Erdlyi Dnielnek :) 
 */

import java.awt.*;
import java.awt.event.*;

// Model vezrel mindent
public class Controller extends Frame implements MouseListener, MouseMotionListener {
	
	// bels vltozk az MVC tbbi tagjra
	Model model;
	View view;
	
	Controller() {
		
		// super( "Line Drawer" ); // a setTitle( "Line Drawer" ); helyett lehetne itt super is, kinek mi tetszik
		model = new Model(); // j model
		view = new View( model ); // j view
		
		setTitle( "Line Drawer" ); // Titel belltsa, lehetne helyette az els sorban super("Line Drawer");
		add((Component)view); // javtva, view tartalmaz mindent :)
		
		setSize( 320+8, 320+36 ); // a Windows ablak kerett is beleszmolja a mretbe, sacc/kb ennyit :)
		setResizable( false ); // nem lehet jramretezni
		setVisible( true ); // megjelents
		
		addWindowListener( new WindowAdapter() { // bezrs
				public void windowClosing( WindowEvent e ) {
					System.exit( 0 );
				}
			}
		);
		
		view.addMouseMotionListener(this);
        view.addMouseListener(this);
        
        // Mivel view tartalmaz minden panelt, ezrt rajta keresztl hivatkozunk r
        view.textField.addActionListener( new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						/* Ha rnak a textField-be, s entert nyomnak lekrdezzk.
						   Ha abban karakter van, akkor a rendszer egy Exceptiont dob,
						   s ez a try kell, hogy ne szlljon el a progi... 					
						*/
						Integer grid = Integer.parseInt( view.textField.getText() );
						 model.setGrid( grid ); // ha minden okes, akkor a model megkapja az j grid-et
					} catch ( Exception ex ) {
						System.out.println("rvnytelen karakter...");
					} finally {
						view.repaint(); // az ablakot mindenkppen jrarajzoljuk
					}
				}
			}
		);
        
        view.clear.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				model.clear(); // ha a clear gombra klikkeltnk, model trl mindent
				view.repaint(); // a view pedig teszi a dolgt, rajzol :)
			}
		}
        );
	}
	
	// belpsi pont
	public static void main( String[] args ) {
		new Controller();
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		model.addPoint( e.getX(), e.getY() ); // ha klikkelnk az egrrel, a model teszi a dolgt
		view.repaint(); // a view pedig rajzol, mert ez a dolga
	}
	
	/*  a tbbi metodust is implementlni kell, mert Controller implementlja a MosueListenert s
		a MouseMotinListener interface-t
	*/
	
	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
}
